# Generated by CMake

if("${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" LESS 2.5)
   message(FATAL_ERROR "CMake >= 2.6.0 required")
endif()
cmake_policy(PUSH)
cmake_policy(VERSION 2.6)
#----------------------------------------------------------------
# Generated CMake target import file.
#----------------------------------------------------------------

# Commands may need to know the format version.
set(CMAKE_IMPORT_FILE_VERSION 1)

# Protect against multiple inclusion, which would fail when already imported targets are added once more.
set(_targetsDefined)
set(_targetsNotDefined)
set(_expectedTargets)
foreach(_expectedTarget parcel_coalescing hpx hpx_init hpx_wrap component_storage_component unordered_component partitioned_vector_component iostreams_component io_counters_component memory_component process_component accumulator_component template_accumulator_component template_function_accumulator_component cancelable_action_component jacobi_component_component nqueen_component sine_component random_mem_access_component startup_shutdown_component throttle_component simple_central_tuplespace_component hpx_base_libraries)
  list(APPEND _expectedTargets ${_expectedTarget})
  if(NOT TARGET ${_expectedTarget})
    list(APPEND _targetsNotDefined ${_expectedTarget})
  endif()
  if(TARGET ${_expectedTarget})
    list(APPEND _targetsDefined ${_expectedTarget})
  endif()
endforeach()
if("${_targetsDefined}" STREQUAL "${_expectedTargets}")
  unset(_targetsDefined)
  unset(_targetsNotDefined)
  unset(_expectedTargets)
  set(CMAKE_IMPORT_FILE_VERSION)
  cmake_policy(POP)
  return()
endif()
if(NOT "${_targetsDefined}" STREQUAL "")
  message(FATAL_ERROR "Some (but not all) targets in this export set were already defined.\nTargets Defined: ${_targetsDefined}\nTargets not yet defined: ${_targetsNotDefined}\n")
endif()
unset(_targetsDefined)
unset(_targetsNotDefined)
unset(_expectedTargets)


# The installation prefix configured by this project.
set(_IMPORT_PREFIX "/usr")

# Create imported target parcel_coalescing
add_library(parcel_coalescing SHARED IMPORTED)

set_target_properties(parcel_coalescing PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target hpx
add_library(hpx SHARED IMPORTED)

set_target_properties(hpx PROPERTIES
  INTERFACE_COMPILE_DEFINITIONS "\$<\$<CONFIG:Debug>:HPX_DEBUG>;HPX_ENABLE_ASSERT_HANDLER;\$<\$<CONFIG:Debug>:_DEBUG>;\$<\$<CONFIG:Debug>:DEBUG>;\$<\$<CONFIG:Release>:HPX_DISABLE_ASSERTS>;\$<\$<CONFIG:RelWithDebInfo>:HPX_DISABLE_ASSERTS>;\$<\$<CONFIG:MinSizeRelease>:HPX_DISABLE_ASSERTS>;\$<\$<CONFIG:Release>:BOOST_DISABLE_ASSERTS>;\$<\$<CONFIG:RelWithDebInfo>:BOOST_DISABLE_ASSERTS>;\$<\$<CONFIG:MinSizeRelease>:BOOST_DISABLE_ASSERTS>"
  INTERFACE_COMPILE_OPTIONS "-std=c++17"
  INTERFACE_INCLUDE_DIRECTORIES "${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include;${_IMPORT_PREFIX}/include"
  INTERFACE_LINK_LIBRARIES "hpx::boost;hpx::boost::program_options;hpx::allocator;hpx::hwloc;hpx_base_libraries"
)

# Create imported target hpx_init
add_library(hpx_init STATIC IMPORTED)

set_target_properties(hpx_init PROPERTIES
  INTERFACE_COMPILE_DEFINITIONS "HPX_ENABLE_ASSERT_HANDLER;\$<\$<CONFIG:Debug>:_DEBUG>;\$<\$<CONFIG:Debug>:DEBUG>;\$<\$<CONFIG:Release>:HPX_DISABLE_ASSERTS>;\$<\$<CONFIG:RelWithDebInfo>:HPX_DISABLE_ASSERTS>;\$<\$<CONFIG:MinSizeRelease>:HPX_DISABLE_ASSERTS>;\$<\$<CONFIG:Release>:BOOST_DISABLE_ASSERTS>;\$<\$<CONFIG:RelWithDebInfo>:BOOST_DISABLE_ASSERTS>;\$<\$<CONFIG:MinSizeRelease>:BOOST_DISABLE_ASSERTS>"
  INTERFACE_COMPILE_OPTIONS "-std=c++17"
  INTERFACE_INCLUDE_DIRECTORIES "${_IMPORT_PREFIX}/include"
  INTERFACE_LINK_LIBRARIES "\$<LINK_ONLY:hpx::boost>"
)

# Create imported target hpx_wrap
add_library(hpx_wrap STATIC IMPORTED)

set_target_properties(hpx_wrap PROPERTIES
  INTERFACE_COMPILE_DEFINITIONS "HPX_ENABLE_ASSERT_HANDLER;\$<\$<CONFIG:Debug>:_DEBUG>;\$<\$<CONFIG:Debug>:DEBUG>;\$<\$<CONFIG:Release>:HPX_DISABLE_ASSERTS>;\$<\$<CONFIG:RelWithDebInfo>:HPX_DISABLE_ASSERTS>;\$<\$<CONFIG:MinSizeRelease>:HPX_DISABLE_ASSERTS>;\$<\$<CONFIG:Release>:BOOST_DISABLE_ASSERTS>;\$<\$<CONFIG:RelWithDebInfo>:BOOST_DISABLE_ASSERTS>;\$<\$<CONFIG:MinSizeRelease>:BOOST_DISABLE_ASSERTS>"
  INTERFACE_COMPILE_OPTIONS "-std=c++17"
  INTERFACE_INCLUDE_DIRECTORIES "${_IMPORT_PREFIX}/include"
  INTERFACE_LINK_LIBRARIES "hpx;-Wl,-wrap=main"
)

# Create imported target component_storage_component
add_library(component_storage_component SHARED IMPORTED)

set_target_properties(component_storage_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx;unordered_component"
)

# Create imported target unordered_component
add_library(unordered_component SHARED IMPORTED)

set_target_properties(unordered_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target partitioned_vector_component
add_library(partitioned_vector_component SHARED IMPORTED)

set_target_properties(partitioned_vector_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target iostreams_component
add_library(iostreams_component SHARED IMPORTED)

set_target_properties(iostreams_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target io_counters_component
add_library(io_counters_component SHARED IMPORTED)

set_target_properties(io_counters_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target memory_component
add_library(memory_component SHARED IMPORTED)

set_target_properties(memory_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target process_component
add_library(process_component SHARED IMPORTED)

set_target_properties(process_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target accumulator_component
add_library(accumulator_component SHARED IMPORTED)

set_target_properties(accumulator_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target template_accumulator_component
add_library(template_accumulator_component SHARED IMPORTED)

set_target_properties(template_accumulator_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target template_function_accumulator_component
add_library(template_function_accumulator_component SHARED IMPORTED)

set_target_properties(template_function_accumulator_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target cancelable_action_component
add_library(cancelable_action_component SHARED IMPORTED)

set_target_properties(cancelable_action_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target jacobi_component_component
add_library(jacobi_component_component SHARED IMPORTED)

set_target_properties(jacobi_component_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx;iostreams_component"
)

# Create imported target nqueen_component
add_library(nqueen_component SHARED IMPORTED)

set_target_properties(nqueen_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target sine_component
add_library(sine_component SHARED IMPORTED)

set_target_properties(sine_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target random_mem_access_component
add_library(random_mem_access_component SHARED IMPORTED)

set_target_properties(random_mem_access_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target startup_shutdown_component
add_library(startup_shutdown_component SHARED IMPORTED)

set_target_properties(startup_shutdown_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target throttle_component
add_library(throttle_component SHARED IMPORTED)

set_target_properties(throttle_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target simple_central_tuplespace_component
add_library(simple_central_tuplespace_component SHARED IMPORTED)

set_target_properties(simple_central_tuplespace_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "hpx"
)

# Create imported target hpx_base_libraries
add_library(hpx_base_libraries INTERFACE IMPORTED)

set_target_properties(hpx_base_libraries PROPERTIES
  INTERFACE_LINK_LIBRARIES "atomic;dl;rt"
)

if(CMAKE_VERSION VERSION_LESS 3.0.0)
  message(FATAL_ERROR "This file relies on consumers using CMake 3.0.0 or greater.")
endif()

# Load information for each installed configuration.
get_filename_component(_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)
file(GLOB CONFIG_FILES "${_DIR}/HPXTargets-*.cmake")
foreach(f ${CONFIG_FILES})
  include(${f})
endforeach()

# Cleanup temporary variables.
set(_IMPORT_PREFIX)

# Loop over all imported files and verify that they actually exist
foreach(target ${_IMPORT_CHECK_TARGETS} )
  foreach(file ${_IMPORT_CHECK_FILES_FOR_${target}} )
    if(NOT EXISTS "${file}" )
      message(FATAL_ERROR "The imported target \"${target}\" references the file
   \"${file}\"
but this file does not exist.  Possible reasons include:
* The file was deleted, renamed, or moved to another location.
* An install or uninstall procedure did not complete successfully.
* The installation package was faulty and contained
   \"${CMAKE_CURRENT_LIST_FILE}\"
but not all the files it references.
")
    endif()
  endforeach()
  unset(_IMPORT_CHECK_FILES_FOR_${target})
endforeach()
unset(_IMPORT_CHECK_TARGETS)

# This file does not depend on other imported targets which have
# been exported from the same project but in a separate export set.

# Commands beyond this point should not need to know the version.
set(CMAKE_IMPORT_FILE_VERSION)
cmake_policy(POP)
